#ifndef	_CG_WATER_H_
#define _CG_WATER_H_

#include <windows.h>
#include <mmsystem.h>
#include <assert.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <Cg/Cg.h>
#include <Cg/CgD3D9.h>

struct Vertex
{
    float x, y, z;
    DWORD color;
    float tu, tv;

    enum FVF
    {
        FVF_Flags = D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1
    };
};

class CG_Water
{
public:
	CG_Water();
	~CG_Water();
	void Init(LPDIRECT3DDEVICE9 pDevice, D3DXVECTOR3 position, float Width, float Height,
					const LPWSTR WaterTextureName, const LPWSTR SkyTextureName);
	void Rander(D3DXVECTOR3 eyePosition);

private:

	void setShaderConstants(D3DXVECTOR3 eyePosition);


	LPDIRECT3DDEVICE9       m_pD3DDevice;
	LPDIRECT3DVERTEXBUFFER9 m_pVertexBuffer;
	LPDIRECT3DTEXTURE9      m_pTexture_Water;
	LPDIRECT3DTEXTURE9      m_pTexture_Sky;
	LPDIRECT3DVERTEXDECLARATION9 m_pVertexDeclaration;
	
	D3DLIGHT9               m_Light;

	D3DXVECTOR3 m_Position;

	CGcontext   g_CGcontext;
	CGprogram   g_CGprogram_vertex;
	CGprogram   g_CGprogram_pixel;
	CGparameter g_CGparam_WorldViewProj;

	CGparameter g_CGparam_time;
	CGparameter g_CGparam_textureScale;
	CGparameter g_CGparam_waveFreq;
	CGparameter g_CGparam_waveAmp;
	CGparameter g_CGparam_BumpScale;
	CGparameter g_CGparam_bumpSpeed;
	CGparameter g_CGparam_EyePosition;

	CGparameter g_CGparam_NormalMap;
	CGparameter g_CGparam_SkyMap;
	CGparameter g_CGparam_deepColor;
	CGparameter g_CGparam_shallowColor;
	CGparameter g_CGparam_waterAmount;
	CGparameter g_CGparam_reflectionColor;
	CGparameter g_CGparam_reflectionAmount;
	CGparameter g_CGparam_reflectionBlur;
	CGparameter g_CGparam_fresnelPower;
	CGparameter g_CGparam_fresnelBias;
	CGparameter g_CGparam_hdrMultiplier;

};

#endif