// TestingMFC_3DView.cpp : implementation of the CTestingMFC_3DView class
//

#include "stdafx.h"
#include "TestingMFC_3D.h"

#include "TestingMFC_3DDoc.h"
#include "TestingMFC_3DView.h"
#include "Shader/Shader_Water.h"
#include "Shader/camera.h"
#include "CG/CG_Water.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


LPDIRECT3D9             g_pD3D          = NULL;
LPDIRECT3DDEVICE9       g_pd3dDevice    = NULL;

CG_Water water;
//Shader_Water water;
// CTestingMFC_3DView

IMPLEMENT_DYNCREATE(CTestingMFC_3DView, CView)

BEGIN_MESSAGE_MAP(CTestingMFC_3DView, CView)
END_MESSAGE_MAP()

// CTestingMFC_3DView construction/destruction

CTestingMFC_3DView::CTestingMFC_3DView()
{
	// TODO: add construction code here

}

CTestingMFC_3DView::~CTestingMFC_3DView()
{
    if( g_pd3dDevice != NULL )
        g_pd3dDevice->Release();

    if( g_pD3D != NULL )
        g_pD3D->Release();
}

BOOL CTestingMFC_3DView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}


// CTestingMFC_3DView diagnostics

#ifdef _DEBUG
void CTestingMFC_3DView::AssertValid() const
{
	CView::AssertValid();
}

void CTestingMFC_3DView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CTestingMFC_3DDoc* CTestingMFC_3DView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTestingMFC_3DDoc)));
	return (CTestingMFC_3DDoc*)m_pDocument;
}
#endif //_DEBUG


// CTestingMFC_3DView message handlers

void CTestingMFC_3DView::OnInitialUpdate()
{
	CView::OnInitialUpdate();

	// TODO: Add your specialized code here and/or call the base class
	HWND g_hWnd = GetSafeHwnd();
	g_pD3D = Direct3DCreate9( D3D_SDK_VERSION );

    D3DDISPLAYMODE d3ddm;

    g_pD3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT, &d3ddm );

    D3DPRESENT_PARAMETERS d3dpp;
    ZeroMemory( &d3dpp, sizeof(d3dpp) );

    d3dpp.Windowed               = TRUE;
    d3dpp.SwapEffect             = D3DSWAPEFFECT_DISCARD;
    d3dpp.BackBufferFormat       = d3ddm.Format;
    d3dpp.EnableAutoDepthStencil = TRUE;
    d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
    d3dpp.PresentationInterval   = D3DPRESENT_INTERVAL_IMMEDIATE;

    g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, g_hWnd,
                          D3DCREATE_SOFTWARE_VERTEXPROCESSING,
                          &d3dpp, &g_pd3dDevice );

	
	//
	// Normally we would need to turn lighting off in a simple sample like 
	// this, but this time I've opted to let the effect file to do it for us. 
	// This is one of the benefits of using an effect file; it lets us batch 
	// together all the state changes necessary to create the "effect". This 
	// makes it easier for other programmers to use our effect as it cuts 
	// down on the amount of Direct3D code that has to be added to their code 
	// before the effect will work as intended. In essence, an effect file is 
	// a way of scripting complex render-state changes, which would normally 
	// require the addition of compiled code.
	//

	//g_pd3dDevice->SetRenderState( D3DRS_LIGHTING, FALSE );
	
	g_pd3dDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );
	D3DXMATRIXA16 g_matProj;

	D3DXMatrixPerspectiveFovLH( &g_matProj, D3DXToRadian( 45.0f ), 
                                640.0f / 480.0f, 0.1f, 100.0f );
    g_pd3dDevice->SetTransform( D3DTS_PROJECTION, &g_matProj );

	water.Init(g_pd3dDevice, D3DXVECTOR3(0,-5,0), 1000, 1000, L"CG/waves2.dds", L"CG/SkyBox_Top.jpg");
/*	camera_info a;
	a.pos = D3DXVECTOR3(-27,8,0);
	a.rotx = 0;
	a.roty = 0;
	a.rotz = 0;
	a.fov = 45;
	a.aspect = 1.33;
	a.nearz = 0.3;
	a.farz = 5000.0;
	water.Init(g_pd3dDevice, D3DXVECTOR3(0,-5,0), 1000, 1000, L"Data/Water/terrain.png", L"CG/SkyBox_Top.jpg", a);
	*/
}

void CTestingMFC_3DView::OnDraw(CDC* /*pDC*/)
{
	CTestingMFC_3DDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	static TCHAR FrameRate[ 50 ];
    static TCHAR TitleBuffer[ 255 ];
	// TODO: add draw code for native data here
	g_pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,
                         D3DCOLOR_COLORVALUE(0.0f,0.0f,1.0f,1.0f), 1.0f, 0 );

	g_pd3dDevice->BeginScene();
	static float y = 0.0f;
	
	water.Rander(D3DXVECTOR3(0,0,0));
	y > 20 ? y = 0.0f : y+=0.5f;
//	water.Rander();

//	if ( m_LastFrameRate != m_Timer.GetFrameRate() )
    {
		CWnd *pWnd = AfxGetMainWnd();
		HWND hwnd = pWnd->m_hWnd;

 //       m_LastFrameRate = m_Timer.GetFrameRate( FrameRate );
        _stprintf( TitleBuffer, _T("camera position y : %f"), y );
		pWnd->SetWindowTextW( TitleBuffer );

    } // End if Frame Rate Altered

	g_pd3dDevice->EndScene();
    g_pd3dDevice->Present( NULL, NULL, NULL, NULL );

	this->Invalidate(0);
}